diff --git a/include/grub/riscv64/linux.h b/include/grub/riscv64/linux.h
index 88d5df781..a1222a207 100644
--- a/include/grub/riscv64/linux.h
+++ b/include/grub/riscv64/linux.h
@@ -19,6 +19,9 @@
 #ifndef GRUB_RISCV64_LINUX_HEADER
 #define GRUB_RISCV64_LINUX_HEADER 1
 
+#include <grub/types.h>
+#include <grub/efi/pe32.h>
+
 #define GRUB_LINUX_RISCV_MAGIC_SIGNATURE 0x05435352 /* 'RSC\0x5' */
 
 #define GRUB_EFI_PE_MAGIC	0x5A4D
@@ -37,6 +40,7 @@ struct linux_riscv_kernel_header
   grub_uint64_t res3;		/* reserved */
   grub_uint32_t magic;		/* Magic number, little endian, "RSC\x05" */
   grub_uint32_t hdr_offset;	/* Offset of PE/COFF header */
+  struct grub_pe_image_header pe_image_header;
 };
 
 #define linux_arch_kernel_header linux_riscv_kernel_header
